/**
 * Camera Access
 * for 3dscanner project
 *
 * \author Marcel Lancelle
 * \date 2002-2003
 * \todo implement vfw access
 * \todo implement selection (and use) of multiple sources!
 */

#ifndef CAMACCESS_HEADER_INCLUDED
#define CAMACCESS_HEADER_INCLUDED

#include "MTwain.h"
#include <stdio.h>
#include "MBmpImg.h"

class CamAccess : public MTwain {
  public:
	CamAccess();
	~CamAccess();

	/// pass application window handle and path for twain log file
	void init(HWND hwnd, char* logFilePath);
	enum ImageAquisitionType {IAT_FILE, IAT_TWAIN, IAT_VFW};

	/// \warning don't forget to delete returned image after usage
	MBmpImg* acquireImg(ImageAquisitionType imgAquisitionType, bool showUI, char* contentDescription);
	bool acquireImgAndSave2File(ImageAquisitionType imgAquisitionType, bool showUI, char* contentDescription, char* imgFileName);

	void selectSource(ImageAquisitionType imageAquisitionType);
	void configSource(ImageAquisitionType imageAquisitionType);

/* (old:)
	bool prepareGetMultiImgNoUI();
	bool acquireImgNoUIAndSave2File(char* imgFileName);
	void stopGetMultiImgNoUI();
	MBmpImg* getSingleImgNoUIModal();
*/
  protected:
	MBmpImg* getSingleImgTwainModal(bool showUI);
	bool initOk(); ///< to be called everytime before using Twain functionality
	HWND hwnd;

	// for twain access:
	void onImageTransferDone(int width, int height, char bitsPerPixel);
	void onStateChange(char oldState, char newState);
	bool camUiControllable;
	bool waitingForAquisition;
	MBmpImg* acquiredBmp;
	char* logFilePath;
// (old:)	char* nextFileName;
};

#endif // CAMACCESS_HEADER_INCLUDED
