/*
include this in resource file:

IDD_DIALOG_ML_INPUT_DIALOG DIALOG DISCARDABLE  0, 0, 141, 95
STYLE DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
CAPTION "Input Dialog"
FONT 8, "MS Sans Serif"
BEGIN
    DEFPUSHBUTTON   "OK",IDOK,7,74,60,14
    PUSHBUTTON      "Cancel",IDCANCEL,74,74,60,14
    EDITTEXT        IDC_EDIT1,33,53,75,15,ES_AUTOHSCROLL | WS_TABSTOP
    LTEXT           "",IDC_STATIC_DESCRIPTION,7,7,127,47
END

IDD_DIALOG_ML_INPUT_DIALOG_LIST DIALOG DISCARDABLE  0, 0, 141, 95
STYLE DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
CAPTION "Input Dialog"
FONT 8, "MS Sans Serif"
BEGIN
    DEFPUSHBUTTON   "OK",IDOK,7,74,60,14
    PUSHBUTTON      "Cancel",IDCANCEL,74,74,60,14
    LISTBOX         IDC_LIST1,33,38,75,30,LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
    LTEXT           "",IDC_STATIC_DESCRIPTION,7,7,127,32
END
*/

/**
example (how to use):
	MLInputDialog inpDlg(hwnd, hinst);
	char* answer;
	if (!inpDlg.getString((char*) &"so", (char*) &"lala", &answer)) return; // return if canceled
	... answer enthlt nun die Antwort

\bug focus is not set automatically on edit field (see SetFocus())
*/

/////////////////////////////////////////////////////////////////////////////
// MLInputDialog dialog

#include <windows.h>

class MLInputDialog {
  public:
	MLInputDialog(HWND hwndParent, HINSTANCE hinst);   // standard constructor

	bool getString(char* msg, char* defaultStr, char** answerPtr);
	bool getDoubleMinMax(char* msg, char* defaultStr, double min, double max, double* answerPtr);
	bool getLongMinMax(char* msg, char* defaultStr, long min, long max, long* answerPtr);
	bool getBool(char* msg, BOOL* answerPtr);
	int getIndexFromList(char* msg, char* stringList); ///< using list box; -1 is returned when cancelled; example for stringList: "Item 1\0Item 2\0\0"
	int doModal();
	int doModalList();

	char* description;
	char* value;
	int listIndex;
  protected:
	HWND hwndParent;
	HINSTANCE hinst;
};
