/**
 * Marching Cubes extension with color and normal per vertex and face
 * to allow fast flat or smooth shading
 * for 3dscanner project
 *
 * \author Marcel Lancelle
 * \date 2002-2003
 */

#ifndef MARCHINGCUBESVERTEXEXT_HEADER_INCLUDED
#define MARCHINGCUBESVERTEXEXT_HEADER_INCLUDED

#include "MarchingCubes.h"

class MarchingCubesVertexExt : public MarchingCubes {
  public:
	/// draws model (OpenGL)
	void drawFlatShaded(bool colored);
	void drawSmoothShaded(bool colored);

	bool write2VRMLFile(char* vrmlFileName, bool exportColor = true);

	void terminate(); /// to be called after the loop with processSlice

	struct MCNormalsStruct {
		float n[3];
	};

	struct MCColorStruct {
		unsigned char r, g, b;
	};

	vector<MCNormalsStruct> faceNormals;
	vector<MCNormalsStruct> vertexNormals;
	vector<MCColorStruct> vertexColors;

  protected:
	void calcFaceNormals();
	void calcVertexNormals();
}; // class MarchingCubes

#endif // MARCHINGCUBESVERTEXEXT_HEADER_INCLUDED
