/**
 * quaternion rotation for user interface (spin 3d objects)
 */

#ifndef QUATERNION_ROTATION_HEADER_INCLUDED
#define QUATERNION_ROTATION_HEADER_INCLUDED

class QuaternionRotation {
public:
	float a, b, c, d; ///< Quaternion = a + bi + cj + dk

	QuaternionRotation();
	void reset();

	/// rotates around unit vector v
	void rotate(float angle, float vx, float vy, float vz);

	/// get the rotation matrix in OpenGL format (transposed)
	void getRotMatrix(float m[4][4]);
};

#endif // QUATERNION_ROTATION_HEADER_INCLUDED
