/**
 * class for a basic ini configuration file support
 * for 3dscanner project
 *
 * \warning lines have max size (see SimpleIni.cpp)
 * \warning space characters are NOT whitespace characters
 * \warning lines starting with ' are ignored (comment lines)
 * \warning when writing to file, comment lines are deleted
 *
 * \author Marcel Lancelle
 * \date 2002-2003
 */

#ifndef SIMPLEINI_HEADER_INCLUDED
#define SIMPLEINI_HEADER_INCLUDED

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <string>
using namespace std;

struct IniEntry {
	char* key;
	char* value;
};

class SimpleIni {
  public:
	SimpleIni(char* fileName);
	~SimpleIni();
	//void addEntry(char* key, char* value);
	char* getEntry(char* key); ///< returns NULL if not existant
	//void writeToFile(); // file is created if not already exists
	bool getIntEntry(char* key, int *val); ///< returns true if value could be read
	bool getFloatEntry(char* key, float *val); ///< returns true if value could be read

  protected:
	char* fileName;
	vector<IniEntry> entries;
};

#endif // SIMPLEINI_HEADER_INCLUDED
