/**
 * frontend for 3DScanner project
 *
 * \author Marcel Lancelle
 * \date 2002-2003
 */

#ifndef FRONTEND_HEADER_INCLUDED
#define FRONTEND_HEADER_INCLUDED

#define ID_MENU						999
#define IDC_MAIN_STATUS				997
#define IDI_3DSCANNER				990
#define IDB_SPLASH					995

// for enabling / disabling menu popups by position
#define ENUM_MENU_FILE				0
#define ENUM_MENU_SCAN				1
#define ENUM_MENU_VIEW				2
#define ENUM_MENU_CONFIG			3
#define ENUM_MENU_HELP				4

// file menu enumerations
#define ENUM_MENU_FILENEW					0
#define ENUM_MENU_FILEOPEN					1
#define ENUM_MENU_FILESAVE					2
// separator								3
#define ENUM_MENU_FILE_MERGE_WITH_PROJECT	4
// separator								5
#define ENUM_MENU_FILE_PROJECT_INFO			6
// separator								7
#define ENUM_MENU_FILE_EXPORT_MODEL_VRML	8
#define ENUM_MENU_FILE_EXPORT_MODEL_OBJ		9
// separator								10
#define ENUM_MENU_FILEEXIT					11

// scan menu enumerations
#define ENUM_MENU_SCAN_CALCAM1			0
#define ENUM_MENU_SCAN_CALCAM			1
#define ENUM_MENU_SCAN_GETIMG			2
#define ENUM_MENU_SCAN_SEGMENTIMG		3
#define ENUM_MENU_SCAN_PREPMANSEG		4
#define ENUM_MENU_SCAN_GENERATE3D		5
#define ENUM_MENU_SCAN_FITVOLUME		6
#define ENUM_MENU_SCAN_SIMPLIFY			7
#define ENUM_MENU_SCAN_TEXTURE			8

// view menu enumerations
#define ENUM_MENU_VIEW_GRID			0
#define ENUM_MENU_VIEW_TEXTURE		1
#define ENUM_MENU_VIEW_SMOOTHSHADED	2
#define ENUM_MENU_VIEW_MESH			3
#define ENUM_MENU_VIEW_NORMALS		4
#define ENUM_MENU_VIEW_VIEWS		5

// config menu enumerations
#define ENUM_MENU_CONFIG_CAM_METHOD_FIRST	0
#define ENUM_MENU_CONFIG_CAM_METHOD_TWAIN	0
#define ENUM_MENU_CONFIG_CAM_METHOD_VFW		1
#define ENUM_MENU_CONFIG_CAM_METHOD_FILE	2
#define ENUM_MENU_CONFIG_CAM_METHOD_LAST	2

// config sub menu enumerations
#define ENUM_MENU_CONFIG_SM			0
#define ENUM_MENU_CONFIG_CAM		1

#define ENUM_MENU_CONFIG_CAM_METHOD	0


#define IDM_FILENEW					100 + ENUM_MENU_FILENEW
#define IDM_FILEOPEN				100 + ENUM_MENU_FILEOPEN
#define IDM_FILESAVE				100 + ENUM_MENU_FILESAVE
#define IDM_FILE_MERGE_WITH_PROJECT	100 + ENUM_MENU_FILE_MERGE_WITH_PROJECT
#define IDM_FILE_PROJECT_INFO		100 + ENUM_MENU_FILE_PROJECT_INFO
#define IDM_FILE_EXPORT_MODEL_VRML	100 + ENUM_MENU_FILE_EXPORT_MODEL_VRML
#define IDM_FILE_EXPORT_MODEL_OBJ	100 + ENUM_MENU_FILE_EXPORT_MODEL_OBJ
#define IDM_FILEEXIT				100 + ENUM_MENU_FILEEXIT

#define IDM_SCAN_CALCAM1			200 + ENUM_MENU_SCAN_CALCAM1
#define IDM_SCAN_CALCAM				200 + ENUM_MENU_SCAN_CALCAM
#define IDM_SCAN_GETIMG				200 + ENUM_MENU_SCAN_GETIMG
#define IDM_SCAN_SEGMENTIMG			200 + ENUM_MENU_SCAN_SEGMENTIMG
#define IDM_SCAN_PREPMANSEG			200 + ENUM_MENU_SCAN_PREPMANSEG
#define IDM_SCAN_GENERATE3D			200 + ENUM_MENU_SCAN_GENERATE3D
#define IDM_SCAN_FITVOLUME			200 + ENUM_MENU_SCAN_FITVOLUME
#define IDM_SCAN_SIMPLIFY			200 + ENUM_MENU_SCAN_SIMPLIFY
#define IDM_SCAN_TEXTURE			200 + ENUM_MENU_SCAN_TEXTURE

#define IDM_VIEW_GRID				300 + ENUM_MENU_VIEW_GRID
#define IDM_VIEW_TEXTURE			300 + ENUM_MENU_VIEW_TEXTURE
#define IDM_VIEW_SMOOTHSHADED		300 + ENUM_MENU_VIEW_SMOOTHSHADED
#define IDM_VIEW_MESH				300 + ENUM_MENU_VIEW_MESH
#define IDM_VIEW_NORMALS			300 + ENUM_MENU_VIEW_NORMALS
#define IDM_VIEW_VIEWS				300 + ENUM_MENU_VIEW_VIEWS

#define IDM_CONFIGSMRESET			400
#define IDM_CONFIGSMSAVE1ROT		401
#define IDM_CONFIGSMSETPORT278H		402
#define IDM_CONFIGSMSETPORT378H		403
#define IDM_CONFIGSMDRVINST			404
#define IDM_CONFIGSMDRVUNINST		405
#define IDM_CONFIGCAMSELECTSOURCE	406
#define IDM_CONFIGCAMMETHODTWAIN	410 + ENUM_MENU_CONFIG_CAM_METHOD_TWAIN
#define IDM_CONFIGCAMMETHODVFW		410 + ENUM_MENU_CONFIG_CAM_METHOD_VFW
#define IDM_CONFIGCAMMETHODFILE		410 + ENUM_MENU_CONFIG_CAM_METHOD_FILE
#define IDM_CONFIGCAMOPTIONS		407
#define IDM_CONFIGCAMSHOWPREVIEWWIN	408
#define IDM_CONFIGSELECTCALPAT		409

#define IDM_HELPCONTENTS			901
#define IDM_HELPABOUT				902



#define IDD_DIALOG_ML_INPUT_DIALOG	800
#define IDC_STATIC_DESCRIPTION		801
#define IDC_EDIT1					802
#define IDD_DIALOG_ML_INPUT_DIALOG_LIST 803
#define IDC_LIST1					804

#define WM_USER_REDRAW			WM_USER + 0
//#define WM_USER_GET_IMG			WM_USER + 1
#define WM_USER_OPENFILE		WM_USER + 2

/// shows 'open file' dialog box
bool getFileNameOpen(HWND hwnd, char* fileNameBuffer, int fnbuffLength, char* filter, char* title, char* defaultExtension);
/// shows 'save file' dialog box
bool getFileNameSave(HWND hwnd, char* fileNameBuffer, int fnbuffLength, char* filter, char* title, char* defaultExtension);

// progress bar
void setupProgressBar(HWND hwnd, HINSTANCE hInstance, int rangeStart, int rangeEnd);
void incrementProgressBar();
void closeProgressBar();

/// splits e.g. 'c:\\dir\\abc.exe' to 'c:\\dir\\', 'abc', 'exe' - don't forget to delete[] last 3 char* !
void splitPathNameExt(char* fullName, char** path, char** name, char** ext);

#endif // FRONTEND_HEADER_INCLUDED
