/*
 * interface to use TSAI's camera calibration methods
 * for 3dscanner project
 *
 * look at TSAI30B3.zip for original code and further informations
 *
 *		Marcel Lancelle 2002
 */

#include <stdio.h>
#include <string.h>
#include "cal_main.h"

extern struct camera_parameters cp;
extern struct calibration_data cd;
extern struct calibration_constants cc;

void calibNonCoplanar(int width, int height, int optimizeCenter /* = 0 (false) */) {
	// initialize the camera parameters (cp) with the appropriate camera constants
	// only for correct calibration required values are correct, others unknown and thus estimatet roughly
	strcpy(camera_type, "my Cam");
	cp.Ncx = width;		// [sel]
	cp.Nfx = width;		// [pix]
	cp.dx = 0.01;		// [mm/sel]
	cp.dy = 0.01;		// [mm/sel]
	cp.dpx = cp.dx * cp.Ncx / cp.Nfx; // [mm/pix]
	cp.dpy = cp.dy;		// [mm/pix]
	cp.Cx = width / 2;	// [pix]
	cp.Cy = height / 2;	// [pix]
	cp.sx = 1.0;		// []

	// load up the calibration data (cd) from the given data file
	//load_cd_data(data_fd, &cd);

	// determine the calibration constants
	if (optimizeCenter)	noncoplanar_calibration_with_full_optimization();
		else noncoplanar_calibration_full_opt_except_center();

	//print_cp_cc_data (stderr, &cp, &cc);
	//print_error_stats (stderr);
	//dump_cp_cc_data (stdout, &cp, &cc);
}
