/**
 * class for multiresolution images
 *
 * for 3DScanner project
 *
 * \todo decimation is not done with a gaussian filter yet
 * \author Marcel Lancelle
 * \date 2002-2003
 */

#ifndef MULTIRESIMT_HEADER_INCLUDED
#define MULTIRESIMT_HEADER_INCLUDED

#include "MBmpImg.h"

class MultiResImg {
  public:
	MultiResImg(char* bmpImgName);
	~MultiResImg();

	/// trilinear interpolation;
	/// influence diameter = 1 means pixel of normal sized image
	//@{
	int getGrayTriLinIntPolXY(float x, float y, float influenceDiam);
	void getRGBTriLinIntPolXY(float x, float y, float influenceDiam, BYTE* r, BYTE* g, BYTE* b);
	//@}

	int getWidth();
	int getHeight();
	int getBitsPerPixel();

  protected:
	MBmpImgPtr* img;
	int imgNum;
};

typedef MultiResImg* MultiResImgPtr;

#endif // MULTIRESIMT_HEADER_INCLUDED
