#include "camTrafo.h"
#include <stdio.h>
#include "math3d.h"

#include <GL/glut.h>

#include "MBmpImg.h"
#include "CalibrateCam.h"

CalibrateCam calCam1, calCam2;
float axisX;
float axisY;

void printMatrix(MAT4x4* m) {
	for (int i=0; i<4; i++) printf("%f %f %f %f\n", m->m[i][0], m->m[i][1], m->m[i][2], m->m[i][3]);
}

void display(void) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();
	glTranslatef(-100, 150, -150);

	glBegin(GL_LINES);


{
double imX0, imY0;
double imX, imY;

calCam1.camTrafo.world2Img(0, 0, 0, &imX0, &imY0);

calCam1.camTrafo.world2Img(100, 0, 0, &imX, &imY);
glColor3f(1.0, 0.3, 0.3);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

calCam1.camTrafo.world2Img(0, 100, 0, &imX, &imY);
glColor3f(0.3, 1.0, 0.3);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

calCam1.camTrafo.world2Img(0, 0, 100, &imX, &imY);
glColor3f(0.3, 0.3, 1.0);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

calCam1.camTrafo.world2Img(axisX, axisY, 0, &imX, &imY);
glColor3f(1.0, 1.0, 1.0);
glVertex3f(imX, -imY, 0);
calCam1.camTrafo.world2Img(axisX, 0, 0, &imX, &imY);
glVertex3f(imX, -imY, 0);
calCam1.camTrafo.world2Img(axisX, axisY, 0, &imX, &imY);
glVertex3f(imX, -imY, 0);
calCam1.camTrafo.world2Img(0, axisY, 0, &imX, &imY);
glVertex3f(imX, -imY, 0);
}
/*
{
double imX0, imY0;
double imX, imY;

calCam2.camTrafo.world2Img(0, 0, 0, &imX0, &imY0);

calCam2.camTrafo.world2Img(100, 0, 0, &imX, &imY);
glColor3f(1.0, 0.0, 0.0);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

calCam2.camTrafo.world2Img(0, 100, 0, &imX, &imY);
glColor3f(0.0, 1.0, 0.0);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

calCam2.camTrafo.world2Img(0, 0, 100, &imX, &imY);
glColor3f(0.0, 0.0, 1.0);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

calCam2.camTrafo.world2Img(axisX, axisY, 0, &imX, &imY);
glColor3f(1.0, 0.3, 1.0);
glVertex3f(imX, -imY, 0);
calCam2.camTrafo.world2Img(axisX, 0, 0, &imX, &imY);
glVertex3f(imX, -imY, 0);
calCam2.camTrafo.world2Img(axisX, axisY, 0, &imX, &imY);
glVertex3f(imX, -imY, 0);
calCam2.camTrafo.world2Img(0, axisY, 0, &imX, &imY);
glVertex3f(imX, -imY, 0);
}
*/

{
//glTranslatef(0, 20, 0);

double xw, yw, zw, xc, yc, zc;



double imX0, imY0;
double imX, imY;

xw = 0; yw = 0; zw = 0;
calCam2.camTrafo.world2Cam(xw, yw, zw, &xc, &yc, &zc);
printf("cc 000: %f %f %f\n", xc, yc, zc);
calCam1.camTrafo.cam2World(xc, yc, zc, &xw, &yw, &zw);
calCam1.camTrafo.world2Img(xw, yw, zw, &imX0, &imY0);

xw = 120; yw = 0; zw = 0;
calCam2.camTrafo.world2Cam(xw, yw, zw, &xc, &yc, &zc);
calCam1.camTrafo.cam2World(xc, yc, zc, &xw, &yw, &zw);
calCam1.camTrafo.world2Img(xw, yw, zw, &imX, &imY);
glColor3f(0.6, 0.0, 0.0);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

xw = 0; yw = 120; zw = 0;
calCam2.camTrafo.world2Cam(xw, yw, zw, &xc, &yc, &zc);
calCam1.camTrafo.cam2World(xc, yc, zc, &xw, &yw, &zw);
calCam1.camTrafo.world2Img(xw, yw, zw, &imX, &imY);
glColor3f(0.0, 0.6, 0.0);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);

xw = 0; yw = 0; zw = 120;
calCam2.camTrafo.world2Cam(xw, yw, zw, &xc, &yc, &zc);
calCam1.camTrafo.cam2World(xc, yc, zc, &xw, &yw, &zw);
calCam1.camTrafo.world2Img(xw, yw, zw, &imX, &imY);
glColor3f(0.0, 0.0, 0.6);
glVertex3f(imX0, -imY0, 0);
glVertex3f(imX, -imY, 0);


glColor3f(1.0, 1.0, 0.0);
xw = axisX; yw = axisY; zw = 0;
calCam2.camTrafo.world2Cam(xw, yw, zw, &xc, &yc, &zc);
calCam1.camTrafo.cam2World(xc, yc, zc, &xw, &yw, &zw);
calCam1.camTrafo.world2Img(xw, yw, zw, &imX, &imY);
glVertex3f(imX, -imY, 0);
xw = axisX; yw = axisY; zw = 50;
calCam2.camTrafo.world2Cam(xw, yw, zw, &xc, &yc, &zc);
calCam1.camTrafo.cam2World(xc, yc, zc, &xw, &yw, &zw);
calCam1.camTrafo.world2Img(xw, yw, zw, &imX, &imY);
glVertex3f(imX, -imY, 0);
}


	glEnd();

	glutSwapBuffers();
}

// Buchstaben; einige andere Tasten
void keyboardFunc(unsigned char key, int x, int y) {
	switch (key) {
		case 27: // escape
		case 'q': exit(0);
   }
}

void reshape(GLsizei width, GLsizei height) {
	glViewport(0, 0, (GLsizei)(width), (GLsizei)(height));

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective( 60.0, // field of view in degree
		(GLfloat)(width)/(GLfloat)(height), // aspect ratio
		1.0, 1000.0); // z near, z far
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

int main(int argc, char *argv[]) {


MBmpImg* calImg1 = new MBmpImg("..\\cam calibration\\drehachse1.bmp");
MBmpImg* calImg2 = new MBmpImg("..\\cam calibration\\drehachse2.bmp");

	if ((calImg1->getWidth() < 50) || (calImg2->getWidth() < 50)) {
		printf("Calibration photos invalid.");
		delete calImg1;
		delete calImg2;
		return 0;
	}

	// calculate calibration parameters of both views

	if (!calCam1.matchAndCalcParams(calImg1) || !calCam2.matchAndCalcParams(calImg2)) {
		printf("Camera parameters couldn't be calculated!");
		delete calImg1;
		delete calImg2;
		return 0;
	}

	calCam1.writeMatchToFile("calCam1Match.txt");
	calCam1.writeParamsToFile("calCam1Params.txt");
	calCam2.writeMatchToFile("calCam2Match.txt");
	calCam2.writeParamsToFile("calCam2Params.txt");

/*
calCam1.camTrafo.rx = 0;
calCam1.camTrafo.ry = 0;
calCam1.camTrafo.rz = 0;
calCam1.camTrafo.tx = 0;
calCam1.camTrafo.ty = 2;
calCam1.camTrafo.tz = 0;

calCam2.camTrafo.rx = 0;
calCam2.camTrafo.ry = 0;
calCam2.camTrafo.rz = 1;
calCam2.camTrafo.tx = 0;
calCam2.camTrafo.ty = 2;
calCam2.camTrafo.tz = 0;
*/

/*
calCam1.camTrafo.f = calCam2.camTrafo.f;
calCam1.camTrafo.k1 = calCam2.camTrafo.k1;
calCam1.camTrafo.cx = calCam2.camTrafo.cx;
calCam1.camTrafo.cy = calCam2.camTrafo.cy;
*/
	calCam1.camTrafo.calcTrafoMatrix();
	calCam2.camTrafo.calcTrafoMatrix();


printMatrix(&calCam1.camTrafo.trafoInverse);
printMatrix(&calCam2.camTrafo.trafoInverse);



{
double xw, yw, zw, xc, yc, zc;

xw = 0; yw = 0; zw = 0;
//xc = 0; yc = 0; zc = 0;
//calCam2.camTrafo.cam2World(xc, yc, zc, &xw, &yw, &zw);
calCam1.camTrafo.world2Cam(xw, yw, zw, &xc, &yc, &zc);

printf("000: %f %f %f\n", xc, yc, zc);
}


/*
{
double imX, imY;
char buf[100];

calCam1.camTrafo.world2Img(0, 0, 0, &imX, &imY);
sprintf((char*) &buf, "x: %f, y: %f", imX, imY);
MessageBox(NULL, buf, "000", MB_OK);

calCam1.camTrafo.world2Img(100, 0, 0, &imX, &imY);
sprintf((char*) &buf, "x: %f, y: %f", imX, imY);
MessageBox(NULL, buf, "100", MB_OK);

calCam1.camTrafo.world2Img(0, 100, 0, &imX, &imY);
sprintf((char*) &buf, "x: %f, y: %f", imX, imY);
MessageBox(NULL, buf, "010", MB_OK);

calCam1.camTrafo.world2Img(0, 0, 100, &imX, &imY);
sprintf((char*) &buf, "x: %f, y: %f", imX, imY);
MessageBox(NULL, buf, "001", MB_OK);
}
*/









	// determine axis by intersecting perpendicular lines to same points of both images
	struct line2dStruct {double x1, y1, x2, y2;};
	double tmpX, tmpY, tmpZ, tmp;

	line2dStruct linesConn[2];
	linesConn[0].x1 = 100;
	linesConn[0].y1 = 0;
	calCam1.camTrafo.world2Cam(linesConn[0].x1, linesConn[0].y1, 0, &tmpX, &tmpY, &tmpZ);
	calCam2.camTrafo.cam2World(tmpX, tmpY, tmpZ, &linesConn[0].x2, &linesConn[0].y2, &tmp);
printf("100,0: %f %f %f\n", linesConn[0].x2, linesConn[0].y2, tmp);

	linesConn[1].x1 = 0;
	linesConn[1].y1 = 100;
	calCam1.camTrafo.world2Cam(linesConn[1].x1, linesConn[1].y1, 0, &tmpX, &tmpY, &tmpZ);
	calCam2.camTrafo.cam2World(tmpX, tmpY, tmpZ, &linesConn[1].x2, &linesConn[1].y2, &tmp);
printf("0,100: %f %f %f\n", linesConn[1].x2, linesConn[1].y2, tmp);

/*/
	linesConn[2].x1 = 0;
	linesConn[2].y1 = 0;
	calCam1.camTrafo.world2Cam(linesConn[2].x1, linesConn[2].y1, 0, &tmpX, &tmpY, &tmpZ);
	calCam2.camTrafo.cam2World(tmpX, tmpY, tmpZ, &linesConn[2].x2, &linesConn[2].y2, &tmp);
printf("0,0: %f %f %f\n", linesConn[2].x2, linesConn[2].y2, tmp);

	linesConn[2].x1 = -76;
	linesConn[2].y1 = -4;
	calCam1.camTrafo.world2Cam(linesConn[2].x1, linesConn[2].y1, 0, &tmpX, &tmpY, &tmpZ);
	calCam2.camTrafo.cam2World(tmpX, tmpY, tmpZ, &linesConn[2].x2, &linesConn[2].y2, &tmp);
printf("axis: %f %f %f\n", linesConn[2].x2, linesConn[2].y2, tmp);
/*/


	line2dStruct lp[2]; // perpendicular lines
	for (int i=0; i<2; i++) {
		lp[i].x1 = 0.5 * (linesConn[i].x1 + linesConn[i].x2);
		lp[i].y1 = 0.5 * (linesConn[i].y1 + linesConn[i].y2);
		lp[i].x2 = linesConn[i].y2 - linesConn[i].y1;
		lp[i].y2 = linesConn[i].x1 - linesConn[i].x2;
printf("lp[%i]: %f %f %f %f\n", i, lp[i].x1, lp[i].y1, lp[i].x2, lp[i].y2);
	}

	// lp[0].1 + a*lp[0].2 = lp[1].1 + b*lp[1].2
	float b1 = lp[0].x2*(lp[1].y1-lp[0].y1) - lp[0].y2*(lp[1].x1-lp[0].x1);
	float b2 = lp[0].y2*lp[1].x2 - lp[0].x2*lp[1].y2;
	if (b2 == 0) {
		MessageBox(NULL, "Camera parameters couldn't be calculated!", "3DScanner", MB_ICONERROR | MB_OK);
//		delete calImg1;
//		delete calImg2;
		return 0;
	}
	float b = b1 / b2;
printf("b: %f\n\n", b);

	axisX = lp[1].x1 + b*lp[1].x2;
	axisY = lp[1].y1 + b*lp[1].y2;
printf("axis: %f %f\n", axisX, axisY);



/*
printf("\n2.trafo\n");
printMatrix(&calCam2.camTrafo.trafo);
printf("\n1.trafoInverse\n");
printMatrix(&calCam1.camTrafo.trafoInverse);

	MAT4x4 w1ToW2;
	copyMat(&calCam2.camTrafo.trafo, &w1ToW2);

printf("\n-> 2.trafo\n");
printMatrix(&w1ToW2);

	multMatMat(&w1ToW2, &calCam1.camTrafo.trafoInverse);

printf("\nmult:\n");
printMatrix(&w1ToW2);

	// w1ToW2 is now transformation between world coords

	// now calculate rotation axis

	for (int i=0; i<4; i++) w1ToW2.m[i][i] -= 1;
	double am[4][4];
	double b[4], x[4];
	for (int j=0; j<4; j++) for (int i=0; i<4; i++) am[i][j] = w1ToW2.m[i][j];
	for (int i=0; i<4; i++) b[i] = 0;
	if (loeseLGS(4, (double*) &am, (double*) &b, (double*) &x)) printf("axis: %f %f %f %f\n", x[0], x[1], x[2], x[3]);
else printf("n\n");

*/

/*
	CamTrafo ct;
	ct.rx = 0;
	ct.ry = 1;
	ct.rz = 0;
	ct.tx = 20;
	ct.ty = 7;
	ct.tz = -4;
	ct.calcTrafoMatrix();

	double xw = 1.1;
	double yw = 0.7;
	double zw = -0.3;

	double xc, yc, zc;

printf("world: %f %f %f\n", xw, yw, zw);

	ct.world2Cam(xw, yw, zw, &xc, &yc, &zc);

printf("cam: %f %f %f\n", xc, yc, zc);

	ct.cam2World(xc, yc, zc, &xw, &yw, &zw);

printf("world: %f %f %f\n", xw, yw, zw);

printf("\n");
printMatrix(&ct.trafo);
printf("\n");
printMatrix(&ct.trafoInverse);
printf("\n");

multMatMat(&ct.trafo, &ct.trafoInverse);
printMatrix(&ct.trafo);
printf("\n");
*/

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(500, 500);
	glutInitWindowPosition(40, 40);
	glutCreateWindow(":-/");
	glutKeyboardFunc(keyboardFunc);
//	glutSpecialFunc(keyboardSpecialFunc);
	glutReshapeFunc(reshape);
//	glutMotionFunc(mouseDrag);
//	glutMouseFunc(mouseButton);
//	glutIdleFunc(update);

	glClearColor (0.0, 0.0, 0.0, 0.0);
glEnable(GL_DEPTH_TEST);
	glutDisplayFunc(display);
	glutMainLoop();

	return 0;   /* ANSI C requires main to return int. */
}
