/*
 *		Marcel Lancelle 2002
 */

#include <stdlib.h>
#include <stdio.h>

#include "PortAccess.h"
#include "StepperMotorParPort.h"

int main(int argc, char *argv[]) {

	if (portAccessBegin(true)) {
		printf("using PortTalk (running Win NT/2K/ME)\n");
	} else {
		switch (portAccessLastError) {
			case PORTACCES_PORTTALK_NOT_INSTALLED:
				printf("PortTalk not installed, stopping\n");
				return 0;
			case PORTACCES_IOCTL_NOT_IMPLEMENTED:
				printf("not using PortTalk (running Win9x)\n");
				portAccessBegin(false);
				break;
			case PORTACCES_UNKNOWN_ERROR:
				printf("unknown error, stopping\n");
				return 0;
		}
	}

	StepperMotorParPort smp;
	smp.setPortAdr(0x378);
	smp.setPower(POWER_HALFSTEP);
	smp.rotateAccelerated(false, 10, 15, 200);
	smp.setPower(POWER_OFF);

	portAccessEnd();

	system("PAUSE");
	return 0;
}
